local M = {}

--Misc Variables
local reset = false
local start = false
local windX = {[1]=0, [2]=0, [3]=0, [4]=0}
local windY = {[1]=0, [2]=0, [3]=0, [4]=0}
local windZ = {[1]=0, [2]=0, [3]=0, [4]=0}
local timer3 = 0
--Blackhole Variables
local properties = {["expandAccDisc"] = true, ["scale"] = 0, ["rotation1"] = 0, ["rotation2"] = 0,["rotation3"] = 0}
local rotationSpeed = {[1]=math.random(1, 10), [2]=math.random(1, 10), [3]=math.random(1, 10)}

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
		start = false
		windX = {[1]=0, [2]=0, [3]=0, [4]=0}
		windY = {[1]=0, [2]=0, [3]=0, [4]=0}
		windZ = {[1]=0, [2]=0, [3]=0, [4]=0}
		properties = {["expandAccDisc"] = true, ["scale"] = 0, ["rotation1"] = 0, ["rotation2"] = 0,["rotation3"] = 0}
		rotationSpeed = {[1]=math.random(1, 10), [2]=math.random(1, 10), [3]=math.random(1, 10)}
		timer3 = 0
	end
end

local function onRaceStart()
	if not start then start = true end
end

local function updateBlackholes()
	if properties["expandAccDisc"] then
		properties["scale"] = properties["scale"]+0.1/2
		TorqueScript.eval([[
			accretionDisc1.scale = "]]..properties["scale"]..[[ ]]..properties["scale"]..[[ ]]..properties["scale"]..[[";
			accretionDisc2.scale = "]]..properties["scale"]..[[ ]]..properties["scale"]..[[ ]]..properties["scale"]..[[";
			accretionDisc3.scale = "]]..properties["scale"]..[[ ]]..properties["scale"]..[[ ]]..properties["scale"]..[[";
		]])
		if properties["scale"] >= 5 then
			properties["expandAccDisc"] = false
		end
	end
	
	properties["rotation1"] = properties["rotation1"]+rotationSpeed[1]
	properties["rotation2"] = properties["rotation2"]+rotationSpeed[2]
	properties["rotation3"] = properties["rotation3"]+rotationSpeed[3]
	TorqueScript.eval([[
		accretionDisc1.rotation = "0 -1 0 ]]..properties["rotation1"]..[[";
		accretionDisc2.rotation = "0 -1 0 ]]..properties["rotation2"]..[[";
		accretionDisc3.rotation = "0 -1 0 ]]..properties["rotation3"]..[[";
	]])
end

local function onPreRender(dt)
	if start then updateBlackholes() end
	
	if reset then
		TorqueScript.eval([[
			accretionDisc1.scale = "0 0 0";
			accretionDisc2.scale = "0 0 0";
			accretionDisc3.scale = "0 0 0";
		]])
		reset = false
	end
end

local function applyGravity(vehicleObject, vehicleName)
	local player = map.objects[map.objectNames[vehicleName]]
	local bh1Object = scenetree.findObject('scenario_player1')
	local bh1 = map.objects[map.objectNames['scenario_player1']]
	local bh2Object = scenetree.findObject('scenario_player2')
	local bh2 = map.objects[map.objectNames['scenario_player2']]
	local bh3Object = scenetree.findObject('scenario_player3')
	local bh3 = map.objects[map.objectNames['scenario_player3']]
	
	local bh1Distance = math.floor(math.abs((player.pos-bh1.pos):length()))
	local bh2Distance = math.floor(math.abs((player.pos-bh2.pos):length()))
	local bh3Distance = math.floor(math.abs((player.pos-bh3.pos):length()))

	local i = 0
	
	while i<3 do
		local currentBH, distance, defaultDistance
		if i == 0 then 
			currentBH = bh1Object
			distance = bh1Distance
			defaultDistance = 1305
		elseif i == 1 then 
			currentBH = bh2Object
			distance = bh2Distance
			defaultDistance = 1464
		elseif i == 2 then
			currentBH = bh3Object
			distance = bh3Distance
			defaultDistance = 1434
		end
		
		local multiplier = 10000
		
		if vehicleObject:getPosition().x > currentBH:getPosition().x then 
			windX[i+1] = -(defaultDistance*multiplier/(distance*distance))
		elseif vehicleObject:getPosition().x < currentBH:getPosition().x then 
			windX[i+1] = (defaultDistance*multiplier/(distance*distance))
		end
		
		if vehicleObject:getPosition().y > currentBH:getPosition().y then 
			windY[i+1] = -(defaultDistance*multiplier/(distance*distance))
		elseif vehicleObject:getPosition().y < currentBH:getPosition().y then 
			windY[i+1] = (defaultDistance*multiplier/(distance*distance))
		end
		
		if vehicleObject:getPosition().z > currentBH:getPosition().z then 
			windZ[i+1] = -(defaultDistance*multiplier/(distance*distance))
		elseif vehicleObject:getPosition().z < currentBH:getPosition().z then 
			windZ[i+1] = (defaultDistance*multiplier/(distance*distance))
		end
		
		i = i+1
	end

	windX[4] = windX[1]+windX[2]+windX[3]
	windY[4] = windY[1]+windY[2]+windY[3]
	windZ[4] = windZ[1]+windZ[2]+windZ[3]
	
	if     windX[4] >  1000 then windX[4] =  1000
	elseif windX[4] < -1000 then windX[4] = -1000 end
	if     windY[4] >  1000 then windY[4] =  1000
	elseif windY[4] < -1000 then windY[4] = -1000 end
	if     windZ[4] >  1000 then windZ[4] =  1000
	elseif windZ[4] < -1000 then windZ[4] = -1000 end
	
	--ui_message('Wind: '..windX[4]..' '..windY[4]..' '..windZ[4]..'', 1, 'A')

	local windLuaCommand = 'obj:setWind('..windX[4]..','..windY[4]..','..windZ[4]..')'
	vehicleObject:queueLuaCommand(windLuaCommand)
end

local function getNumberOfVehicles(veh, vehName)
	local first = true
	local i = 0
	while true do
		if first and scenetree.findObject('clone') ~= nil then --First clone is always clone, then clone0 etc
			table.insert(veh, scenetree.findObject('clone'))
			table.insert(vehName, 'clone')
			first = false
		elseif not first and scenetree.findObject('clone'..i) then 
			table.insert(veh, scenetree.findObject('clone'..i))
			table.insert(vehName, 'clone'..i)
			i = i+1 --Clone vehicle exists, so there may be more
		else break --No clone vehicle exists therefore stop looking
		end
	end
	
	return veh, vehName
end

local function onRaceTick(raceTickTime)
	timer3 = timer3+raceTickTime
	
	if timer3 % 1 == 0 and properties["scale"] > 1 then
		local vehicles, vehicleNames = {scenetree.findObject('scenario_player0')}, {'scenario_player0'}
		vehicles, vehicleNames = getNumberOfVehicles(vehicles, vehicleNames)
		for key, value in ipairs(vehicles) do applyGravity(value, vehicleNames[key]) end
	end
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M